variables:
  # This will supress any download for dependencies and plugins or upload messages which would clutter the console log.
  # `showDateTime` will show the passed time in milliseconds. You need to specify `--batch-mode` to make this work.
  MAVEN_OPTS: "-Dhttps.protocols=TLSv1.2 -Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=WARN -Dorg.slf4j.simpleLogger.showDateTime=true -Djava.awt.headless=true"


stages:     
  - build
  - push
  - deploy

build-job:
  image: maven:3.8.6-openjdk-11  
  stage: build
  when: always
  cache:
    paths:
        - .m2/repository
  script:
    - mvn clean install
  artifacts:
    name: "server-build-$CI_COMMIT_SHORT_SHA"
    paths:
      - target/
    expire_in: 1 days

push-job:
  image: docker:latest
  stage: push 
  services:
    - docker:dind
  dependencies: 
    - build-job
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD"
  when: manual 
  allow_failure: false
  script:
    - |
      if [[ "$CI_COMMIT_BRANCH" == "$CI_DEFAULT_BRANCH" ]]; then
        export IMAGE_TAG=":release";
      else 
        IMAGE_TAG=":dev"
      fi
    - echo "Running on branch '$CI_COMMIT_BRANCH' with tag '${IMAGE_TAG}'"
    - docker build -t "$CI_REGISTRY_IMAGE${IMAGE_TAG}" .
    - docker push "$CI_REGISTRY_IMAGE${IMAGE_TAG}"

deploy-job:
  stage: deploy
  when: on_success
  needs:
    - job: push-job
      artifacts: false
  before_script:
    - apt-get update -qq
    - |
      if [[ "$CI_COMMIT_BRANCH" == "$CI_DEFAULT_BRANCH" ]]; then
        export IMAGE_TAG=":release";
        export SERVER_ADDRESS="$RELEASE_SERVER_ADDRESS";
        export SERVER_USER="$RELEASE_SERVER_USER";
        export SSH_KEY="$RELEASE_SERVER_SSH_KEY";
      else 
        export IMAGE_TAG=":dev";
        export SERVER_ADDRESS="$DEV_SERVER_ADDRESS";
        export SERVER_USER="$DEV_SERVER_USER";
        export SSH_KEY="$DEV_SERVER_SSH_KEY";
      fi
# Setup SSH deploy keys
    - 'which ssh-agent || ( apt-get install -qq openssh-client )'
    - eval $(ssh-agent -s)
    - ssh-add <(echo "$SSH_KEY" | base64 -d)
    - mkdir -p ~/.ssh
    - '[[ -f /.dockerenv ]] && echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
  script:
    - ssh $SERVER_USER@$SERVER_ADDRESS "sudo docker-compose pull && sudo docker-compose up -d && exit"
